/************************************************************************************
*
* File name: Main.c
* Project  : OLEDTest
* Processor: STC8F2K16S2
* Compiler : Keil C51 Compiler
* 
* Author : 
* Version: 1.00
* Date   : 2020.7.6
* Modification: none
* 
* Description:
*
* Others: none;
*
* Function List:
*
* 1. void delay(unsigned int z) -- ڵʾЧʱ,STC8F2K16S2 16MHZ z=1ʱԼʱ1ms
* 2. void main(void) -- 
*
* History: none;
*
*************************************************************************************/

#include "STC8F2K16S2.h"
#include "intrins.h"
#include "STC_IIC.h"
#include "LED.h"
#include "TIME.h"
#include "TM1650.h"
#include "main.h"
unsigned char code tabForDisplay[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,\
                                              0x7d,0x07,0x7f,0x6f};

/********************************************************/
/*********************************************************
*              main                                      *
*********************************************************/
void main(void)
{
	unsigned char b,k,j,i = 0;
    unsigned char red=50,green=50,blue=50;
    
    P_SW2 = 0x80;
    XOSCCR = 0xc0;
    while(!(XOSCCR&1));
    CLKDIV = 0X00;
    CKSEL = 0X01;
    P_SW2 = 0X00;
    
    uart1_Initialization();
    I2c_init();
    led_Initialization();
    led_TurnOff();
	time_DelayMs(10);
	TM1650_Set(0x48,0x31); //ʾ
    time_DelayMs(10);
    TM1650_Set(0x68,0);
    TM1650_Set(0x6a,0);
    TM1650_Set(0x6c,0);
    TM1650_Set(0x6e,0);
	while(1)
	{
        k = Scan_Key();                     
        //time_DelayMs(10);
        if(k)
        {
            switch (k)
            {
                case 1: i = 0x68;break;
                 case 2: i = 0x6A;break;
                  case 3: i = 0x6C;break;
                default:break;
            }
            TM1650_Set(0x68,0x00);
            TM1650_Set(0x6a,0x00);
            TM1650_Set(0x6c,0x00);
            TM1650_Set(i,tabForDisplay[k]);
            time_DelayMs(300);
            b = k;
            k = 0; 
        }
        switch (b)
        {
            case 1: if(red<255)
            {
                for(;red<255;red++)
                {
                    green = red;
                    blue = red;
                    send_dmx(red,green,blue);
                    time_DelayMs(10); 
                    TM1650_Set(0x68,tabForDisplay[red/100]);
                    TM1650_Set(0x6a,tabForDisplay[red%100/10]);
                    TM1650_Set(0x6c,tabForDisplay[red%100%10+1]);
                    time_DelayMs(10);
                }                                    
            }break;
            case 2:if(red<128)
            {
                for(;red<128;red++)
                {
                    green = red;
                    blue = red;
                    send_dmx(red,green,blue);
                    time_DelayMs(10); 
                    TM1650_Set(0x68,tabForDisplay[red/100]);
                    TM1650_Set(0x6a,tabForDisplay[red%100/10]);
                    TM1650_Set(0x6c,tabForDisplay[red%100%10+1]);
                    time_DelayMs(10);
                }                
            }
            else if(red>128)
            {
                for(;red>128;red--)
                {
                    green = red;
                    blue = red;
                    send_dmx(red,green,blue);
                    time_DelayMs(10); 
                    TM1650_Set(0x68,tabForDisplay[red/100]);
                    TM1650_Set(0x6a,tabForDisplay[red%100/10]);
                    TM1650_Set(0x6c,tabForDisplay[red%100%10-1]);
                    time_DelayMs(10);
                }  
            }break;
            case 3:if(red>0)
            {
                for(;red>0;red--)
                {
                    green = red;
                    blue = red;
                    send_dmx(red,green,blue);
                    time_DelayMs(10); 
                    TM1650_Set(0x68,tabForDisplay[red/100]);
                    TM1650_Set(0x6a,tabForDisplay[red%100/10]);
                    TM1650_Set(0x6c,tabForDisplay[red%100%10-1]);
                    time_DelayMs(10);
                } 
            }break;  
            default:b = 0;break;            
        }
        b = 0;
        send_dmx(red,green,blue);
        if(++j==30)
        {
            j=0;
           led_TurnOn();
        }
        else
        {
           led_TurnOff();
        }
        time_DelayMs(10);
        send_dmx(red,green,blue);
	}
}
