/*
*
* * * STCISP * * *
*
*/
#include "STC_IIC.h"
#include "intrins.h"

bit busy;


void I2C_Isr() interrupt 24
{
    _push_(P_SW2);
    P_SW2 |= 0x80;
    if (I2CMSST & 0x40)
    {
        I2CMSST &= ~0x40;                      //жϱ־
        busy = 0;
    }
    _pop_(P_SW2);
}

void Start()
{
    busy = 1;
    I2CMSCR = 0x81;                             //START
    while (busy);
}

void SendData(char dat)
{
    I2CTXD = dat;                               //дݵݻ
    busy = 1;
    I2CMSCR = 0x82;                             //SEND
    while (busy);
}

void RecvACK()
{
    busy = 1;
    I2CMSCR = 0x83;                             //ͶACK
    while (busy);
}
/**********************************************************/

char RecvData()
{
    busy = 1;
    I2CMSCR = 0x84;                             //RECV
    while (busy);
    return I2CRXD;
}
/*
void SendACK()
{
    I2CMSST = 0x00;                             //ACKź
    busy = 1;
    I2CMSCR = 0x85;                             //ACK
    while (busy);
}

void SendNAK()
{
    I2CMSST = 0x01;                             //NAKź
    busy = 1;
    I2CMSCR = 0x85;                             //ACK
    while (busy);
}
*/
/************************************************************/
void Stop()
{
    busy = 1;
    I2CMSCR = 0x86;                             //STOP
    while (busy);
}

void I2c_init(void)
{
    P_SW2 = 0x00;   //лP1.5(SCL_1)/P1.4(SDA_1)
//    P_SW2 = 0x10;   //лP2.5(SCL_2)/P2.4(SDA_2)
//    P_SW2 = 0x20;   //лP7.7(SCL_3)/P7.6(SDA_3)
//	  P_SW2 = 0x30;     //лP3.2(SCL_4)/P3.3(SDA_4)
    P_SW2 |= 0x80;

    I2CCFG = 0xc0;                             //ʹI2Cģʽ
    I2CMSST = 0x00;
    EA = 1;
}

